﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace XamDataGridInTabItem
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Data = new ObservableCollection<Data>
            {
                new Data { ID = 1, Name = "Name 1", Value = 123 },
                new Data { ID = 2, Name = "Name 2", Value = 34 },
                new Data { ID = 3, Name = "Name 3", Value = 22 },
                new Data { ID = 4, Name = "Name 4", Value = 564 },
                new Data { ID = 5, Name = "Name 5", Value = 111 },
            };

            DataContext = this;
        }

        public ObservableCollection<Data> Data { get; set; }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Data[3].Name = "New name";
            Data[3].Value = 123;
        }

        private void XamDataGrid_DataValueChanged(object sender, Infragistics.Windows.DataPresenter.Events.DataValueChangedEventArgs e)
        {
            e.Record.RefreshSortPosition();
        }
    }

    public class Data : INotifyPropertyChanged
    {
        private int id;
        public int ID
        {
            get { return id; }
            set 
            {
                id = value;
                UpdateProp("ID");
            }
        }

        private string name;
        public string Name
        {
            get { return name; }
            set 
            {
                name = value;
                UpdateProp("Name");
            }
        }

        private int val;
        public int Value
        {
            get { return val; }
            set 
            {
                val = value;
                UpdateProp("Value");
            }
        }



        public event PropertyChangedEventHandler PropertyChanged;

        public void UpdateProp(string pName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(pName));
            }

        }
    }

}
